#include "mainNode/EgoMotion.h"


namespace car {
  
EgoMotion::EgoMotion(ros::NodeHandle nh)
    : platoonControllerNotify()
      , cruiseControllerNotify()
{
    environmentData = nh.subscribe("environmentData", 1, &EgoMotion::environmentDataCallback, this);
    stmData = nh.subscribe("stmData", 1, &EgoMotion::stmDataCallback, this);
}

void EgoMotion::environmentDataCallback(const environmentDataMsg::ConstPtr & inMsg)
{
    std::cout << "EgoMotion recived new environmentData data (" << inMsg->distance << ", " << inMsg->relativeSpeed << ")." << std::endl;
    distance = inMsg->distance;
    relSpeed = inMsg->relativeSpeed;
    sleep(3);
    computeAndNotify();
    std::cout << "EgoMotion done with environmentData data (" << inMsg->distance << ", " << inMsg->relativeSpeed << ")." << std::endl;
}


void EgoMotion::stmDataCallback(const stmDataMsg::ConstPtr & inMsg)
{
    std::cout << "EgoMotion recived new stmData data (" << inMsg->speed << ", " << inMsg->angle << ")." << std::endl;
    stmSpeed = inMsg->speed;
    sleep(1);
    computeAndNotify();
    std::cout << "EgoMotion done with stmData data (" << inMsg->speed << ", " << inMsg->angle << ")." << std::endl;
}

void EgoMotion::computeAndNotify()
{
    prvSpeed = stmSpeed + relSpeed;
    cruiseControllerNotify();
}

}
